"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable:no-require-imports no-empty */
try {
    // optional
    require("source-map-support").install();
}
catch (e) {
}
var pkg = require("../package.json");
/* tslint:enable:no-require-imports no-empty */
var review = require("./");
var commandpost = require("commandpost");
var root = commandpost
    .create("dtreview <prNumber>")
    .version(pkg.version, "-v, --version")
    .option("--owner <owner>", "target owner (repository owner)", "DefinitelyTyped")
    .option("--repo <repo>", "target repository", "DefinitelyTyped")
    .action(function (opts, args) {
    var num = parseInt(args.prNumber, 10);
    return review
        .generateComment({
        owner: opts.owner[0],
        repo: opts.repo[0],
        number: num,
    }).then(function (comments) {
        console.log(comments.join("\n------\n\n"));
    });
});
commandpost
    .exec(root, process.argv)
    .catch(errorHandler);
function errorHandler(err) {
    if (err instanceof Error && err.stack) {
        console.error(err.stack);
    }
    else {
        console.error(err);
    }
    return Promise.resolve(null).then(function () {
        process.exit(1);
    });
}
//# sourceMappingURL=cli.js.map