"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Client = require("github");
var path = require("path");
var _ = require("lodash");
function getPRInfo(req) {
    return __awaiter(this, void 0, void 0, function () {
        var github, owner, repo, pullRequestResponse, info, pullRequestFilesResponse, blobRequests, fileContentsRequests, additionalFiles, filesByPackage, additionalFilesContentsRequests;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    github = new Client({});
                    github.authenticate({
                        type: "oauth",
                        key: "6dfc3629feef934dadd0",
                        secret: "7524eed1afd84b09f08f1439e7e08860add37c09",
                    });
                    owner = req.owner || "DefinitelyTyped";
                    repo = req.repo || "DefinitelyTyped";
                    return [4 /*yield*/, github.pullRequests.get({
                            owner: owner,
                            repo: repo,
                            number: req.number,
                        })];
                case 1:
                    pullRequestResponse = _a.sent();
                    info = {
                        pr: pullRequestResponse.data,
                        files: [],
                        contents: {},
                        baseContents: {},
                    };
                    return [4 /*yield*/, github.pullRequests.getFiles({
                            owner: owner,
                            repo: repo,
                            number: req.number,
                        })];
                case 2:
                    pullRequestFilesResponse = _a.sent();
                    info.files = pullRequestFilesResponse.data;
                    info.files = info.files.filter(function (file) {
                        switch (path.extname(file.filename)) {
                            case ".ts":
                            case ".tsx":
                                return true;
                            default:
                                return false;
                        }
                    });
                    blobRequests = info.files.map(function (file) {
                        return github.gitdata.getBlob({
                            owner: owner,
                            repo: repo,
                            sha: file.sha,
                        }).then(function (res) {
                            if (res.data.encoding === "utf-8") {
                                info.contents[file.filename] = res.data.content;
                            }
                            else {
                                var b = new Buffer(res.data.content, "base64");
                                info.contents[file.filename] = b.toString();
                            }
                        });
                    });
                    return [4 /*yield*/, Promise.all(blobRequests)];
                case 3:
                    _a.sent();
                    fileContentsRequests = info.files.filter(function (file) { return file.status === "modified"; }).map(function (file) {
                        return github.repos.getContent({
                            owner: owner,
                            repo: repo,
                            path: file.filename,
                            ref: info.pr.base.ref,
                        }).then(function (res) {
                            if (res.data.encoding === "utf-8") {
                                info.baseContents[file.filename] = res.data.content;
                            }
                            else {
                                var b = new Buffer(res.data.content, "base64");
                                info.baseContents[file.filename] = b.toString();
                            }
                        });
                    });
                    return [4 /*yield*/, Promise.all(fileContentsRequests)];
                case 4:
                    _a.sent();
                    additionalFiles = [];
                    filesByPackage = _.groupBy(info.files, function (file) {
                        var parts = path.dirname(file.filename).split("/");
                        // /types/{package}
                        return parts[1];
                    });
                    _.forEach(filesByPackage, function (pkg) {
                        var index = pkg.find(function (file) { return path.basename(file.filename) === "index.d.ts"; });
                        if (!index) {
                            var filename = path.dirname(_.first(pkg).filename) + "/index.d.ts";
                            additionalFiles.push(filename);
                        }
                    });
                    additionalFilesContentsRequests = additionalFiles.map(function (filename) {
                        return github.repos.getContent({
                            owner: owner,
                            repo: repo,
                            path: filename,
                            ref: info.pr.base.ref,
                        }).then(function (res) {
                            if (res.data.encoding === "utf-8") {
                                info.baseContents[filename] = res.data.content;
                            }
                            else {
                                var b = new Buffer(res.data.content, "base64");
                                info.baseContents[filename] = b.toString();
                            }
                        });
                    });
                    return [4 /*yield*/, Promise.all(additionalFilesContentsRequests)];
                case 5:
                    _a.sent();
                    return [2 /*return*/, info];
            }
        });
    });
}
exports.getPRInfo = getPRInfo;
//# sourceMappingURL=github.js.map