"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var url = require("url");
var github = require("./github");
var npm = require("npm");
var header = require("definition-header");
function processAdded(reviewResult) {
    var comment = "";
    function log(text) {
        comment += text + "\n";
    }
    var info = reviewResult.parent;
    var file = reviewResult.file;
    var packageName = file.filename.split("/")[1] || "package-name";
    var npmPackageName = packageName.indexOf("__") !== -1
        ? "@" + packageName.split("__").join("/") // 'bla__foo' on the file system -> '@bla/foo' on npm
        : packageName;
    var testFileNames = [packageName + "-tests.ts", packageName + "-tests.tsx"];
    var testFileExists = info.files.filter(function (f) {
        var basename = path.basename(f.filename);
        return testFileNames.indexOf(basename) !== -1;
    }).length !== 0;
    var content = info.contents[file.filename];
    var headerInfo = header.parse(content);
    if (headerInfo.success) {
        reviewResult.baseHeader = headerInfo;
    }
    return new Promise(function (resolve) {
        npm.load(null, function () {
            npm.commands.info([npmPackageName], true, function (err, result) {
                var npmExists = false;
                var info;
                if (!err && reviewResult.baseHeader) {
                    info = result[Object.keys(result)[0]] || {};
                    if (info.homepage && reviewResult.baseHeader.value.project[0].url) {
                        var infoUrl = url.parse(info.homepage);
                        var headerUrl = url.parse(reviewResult.baseHeader.value.project[0].url);
                        if (infoUrl.host === headerUrl.host && infoUrl.path === headerUrl.path) {
                            // ignore protocol mismatch
                            npmExists = true;
                        }
                    }
                }
                log("Checklist");
                log("");
                log("* [" + (npmExists ? "X" : " ") + "] is correct [naming convention](http://definitelytyped.org/guides/contributing.html#naming-the-file)?");
                if (npmExists) {
                    log("  * https://www.npmjs.com/package/" + npmPackageName + " - " + info.homepage);
                }
                else {
                    log("  * https://www.npmjs.com/package/" + npmPackageName);
                    log("  * http://bower.io/search/?q=" + npmPackageName);
                    log("  * others?");
                }
                log("* [" + (testFileExists ? "X" : " ") + "] has a [test file](http://definitelytyped.org/guides/contributing.html#tests)? (" + testFileNames.join(" or ") + ")");
                reviewResult.message = comment;
                resolve(reviewResult);
            });
        });
    });
}
function convertAuthorToAccount(author) {
    switch (author.url) {
        case "https://asana.com":
            return ["@pspeter3", "@vsiao"];
        case "http://phyzkit.net/":
            return ["@kontan"];
        case "http://ianobermiller.com":
            return ["@ianobermiller"];
        case "https://invent.life/":
            return ["@seanhess"];
        case "http://blog.gandjustas.ru":
            return ["@gandjustas"];
        case "http://www.esri.com":
            return ["@dasa"];
        case "http://devexpress.com/":
            return ["@Seteh"];
        case "https://github.com/a904guy/,http://a904guy.com":
            return ["@a904guy"];
        case "http://www.colsa.com/":
            return ["@ColsaCorp"];
        case "http://guido.io":
            return ["@gzuidhof"];
        case "http://raphael.atallah.me":
            return ["@devnixs"];
        case "https://github.com/ButterFaces/ButterFaces":
            return ["@larmic"];
        case "http://midnight-design.at/":
            return ["@MidnightDesign"];
        case "http://pspeter3.com":
            return ["@pspeter3"];
        case "http://dreampulse.de":
            return ["@dreampulse"];
        case "http://handsoncode.net/":
            return ["@swistach"];
        case "http://samchon.org":
            return ["@samchon"];
        case "http://www.tim-jonischkat.de":
            return ["@timjonischkat"];
        case "http://leancloud.cn":
            return ["@wujun4code"];
        case "http://alan.norbauer.com/":
            return ["@altano"];
        case "http://cs.toronto.edu/~wehr":
            return ["@DustinWehr"];
        default:
            return null;
    }
}
function convertInactiveAuthor(author) {
    switch (author) {
        case "@benjaminjackman":
            return "@.benjaminjackman";
        case "@Bartvds":
        case "@bartvds":
            return "@.Bartvds";
        case "@job13er":
            return "@.job13er";
        default:
            return author;
    }
}
function processModified(reviewResult) {
    var comment = "";
    function log(text) {
        comment += text + "\n";
    }
    var info = reviewResult.parent;
    var file = reviewResult.file;
    var content = info.baseContents[file.filename];
    var headerInfo = header.parse(content);
    if (!headerInfo.success) {
        reviewResult.message = "can't parse definition header...";
        return Promise.resolve(reviewResult);
    }
    reviewResult.baseHeader = headerInfo;
    headerInfo.value.authors.forEach(function (author) {
        if (reviewResult.parent.pr.user.html_url === author.url) {
            return;
        }
        var accountNames = convertAuthorToAccount(author);
        if (accountNames) {
            reviewResult.authorAccounts = reviewResult.authorAccounts.concat(accountNames);
            return;
        }
        var regexp1 = /https?:\/\/github.com\/(.+)\/?/;
        var regexp2 = /https?:\/\/([^.]+)\.github\.io\/?/;
        var reArray = regexp1.exec(author.url) || regexp2.exec(author.url) || [];
        var accountName = reArray[1];
        if (accountName) {
            reviewResult.authorAccounts.push("@" + accountName);
        }
        else {
            reviewResult.unknownAuthors.push(author);
        }
    });
    reviewResult.authorAccounts = reviewResult.authorAccounts.map(function (author) { return convertInactiveAuthor(author); });
    var accountNames = [].concat(reviewResult.authorAccounts);
    reviewResult.unknownAuthors.forEach(function (author) {
        accountNames.push(author.name + " (account can't be detected)");
    });
    if (accountNames.length !== 0) {
        log("to author" + (accountNames.length === 1 ? "" : "s") + " (" + accountNames.join(" ") + "). Could you review this PR?");
        log(":+1: or :-1:?");
    }
    reviewResult.message = comment;
    return Promise.resolve(reviewResult);
}
function processRemoved(reviewResult) {
    reviewResult.message = "REMOVED!";
    return Promise.resolve(reviewResult);
}
function generateComment(pr) {
    return constructReviewResult(pr)
        .then(function (ts) { return ts.map(function (result) { return ["*" + result.file.filename + "*", "", result.message].join("\n"); }); });
}
exports.generateComment = generateComment;
function constructReviewResult(pr) {
    var _this = this;
    return github
        .getPRInfo(pr)
        .then(function (info) {
        var ps = info.files
            .filter(function (file) { return /\.d\.ts(x)?$/.test(file.filename); })
            .map(function (file) {
            var reviewResult = {
                parent: info,
                file: file,
                authorAccounts: [],
                unknownAuthors: [],
            };
            if (file.status === "modified") {
                return processModified(reviewResult).then(function (reviewResult) { return __awaiter(_this, void 0, void 0, function () {
                    var indexFilename, indexReviewResult;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!(path.basename(file.filename) !== "index.d.ts" &&
                                    reviewResult.message === "can't parse definition header...")) return [3 /*break*/, 2];
                                indexFilename = path.dirname(file.filename) + "/index.d.ts";
                                return [4 /*yield*/, processModified({
                                        parent: info,
                                        file: { filename: indexFilename },
                                        authorAccounts: [],
                                        unknownAuthors: [],
                                    })];
                            case 1:
                                indexReviewResult = _a.sent();
                                reviewResult.baseHeader = indexReviewResult.baseHeader;
                                reviewResult.authorAccounts = indexReviewResult.authorAccounts;
                                reviewResult.unknownAuthors = indexReviewResult.unknownAuthors;
                                reviewResult.message = indexReviewResult.message;
                                _a.label = 2;
                            case 2: return [2 /*return*/, reviewResult];
                        }
                    });
                }); });
            }
            else if (file.status === "added") {
                return processAdded(reviewResult);
            }
            else if (file.status === "removed") {
                return processRemoved(reviewResult);
            }
            reviewResult.message = "unknown status: " + file.status;
            return Promise.resolve(reviewResult);
        });
        return Promise.all(ps);
    });
}
exports.constructReviewResult = constructReviewResult;
//# sourceMappingURL=index.js.map